/* Printing Files */
xScriptContext = uno.getScriptContext() -- wrap first argument into an UNO-proxy object

oDesktop=xScriptContext~getDesktop -- get the desktop (an XDesktop object)

xComponentLoader = oDesktop~XDesktop~XComponentLoader  
						-- get componentLoader interface

/*printing swriter file*/

/* open the swriter - file  */
url = "file:///C:/articel.odt"  -- get the document from the current folder

props = bsf.createArray(.UNO~propertyValue, 1)
props[1] = .UNO~propertyValue~new


props[1]~Name  = "Hidden"
props[1]~Value = box("boolean", .true)
xWriterComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, props)

/* set the printer */
xPrintable = xWriterComponent~XPrintable

props[1]~Name  = "Name"
props[1]~Value = "Brother HL-5030 series" -- the name of your printer

xPrintable~setPrinter(props1)

/* set the print-options */
props[1]~Name  = "Pages"
props[1]~Value = "1"

/* print current file */
xPrintable~print(props2)

/*Printing scalc-File*/
url = "file:///C:/compare.ods"  -- get the document from the current folder
props[1] = .UNO~propertyValue~new
props[1]~Name  = "Hidden"
props[1]~Value = box("boolean", .true)
xCalcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, props)

xSheet=xCalcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0)-
~XSpreadSheet

/* create a cell range, then get the CellRangeAddress */
myRange = xSheet~XCellRange~getCellRangeByName("A1:C5")
myAddr = myRange~XCellRangeAddressable~getRangeAddress

CALL UNO.loadClass "com.sun.star.table.CellRangeAddress"

oAddr = bsf.createArray(.UNO~CellRangeAddress, 1) -- create Java array
oAddr[1] = myAddr                                 -- assign CellRangeAddress
xSheet~XPrintAreas~setPrintAreas(oAddr)           -- set PrintAreas

xPrintable = xCalcComponent~XPrintable
xPrintable~setPrinter(props1)
xPrintable~print(props2)

/*modifying props*/
props = bsf.createArray(.UNO~propertyValue, 2)
props[1] = .UNO~propertyValue~new
props[1]~Name  = "Hidden"
props[1]~Value = box("boolean", .false)
props[2] = .UNO~propertyValue~new
props[2]~Name  = "IsPrintHandout"
props[2]~Value = box("boolean", .true)

url="file:///c:/handout.odp"
xImpressComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, props)

xDrawPagesSupplier = xImpressComponent~XDrawPagesSupplier
xDrawPages = xDrawPagesSupplier~getDrawPages

xPrintable = xImpressComponent~XPrintable
xPrintable~setPrinter(props1)

props = bsf.createArray(.UNO~propertyValue, 2)
props[1] = .UNO~propertyValue~new
props[1]~Name  = "IsPrintHandout"
props[1]~Value = box("boolean", .true)
props[2] = .UNO~propertyValue~new
props[2]~Name  = "Pages"
props[2]~Value = "1-" || xDrawPages~getCount
xPrintable~print(props)

::requires UNO.CLS   -- load UNO support for OpenOffice
